name: Linting and style checking

on:
  pull_request:
    branches:
      - "master"

jobs:
  luacheck:
    name: Luacheck
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@v4

      - name: Prepare
        run: |
          sudo apt-get update
          sudo apt-get install luarocks -y
          sudo luarocks install luacheck

      - name: Run Luacheck
        run: luacheck .

  stylua:
    name: StyLua
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@v4
      - name: Lint with stylua
        uses: JohnnyMorganz/stylua-action@v3
        with:
          token: ${{ secrets.GITHUB_TOKEN }}
          version: latest
          args: --check .

  format-queries:
    name: Lint queries
    runs-on: ubuntu-latest
    env:
      NVIM_TAG: stable
    steps:
      - uses: actions/checkout@v4
      - name: Prepare
        run: |
          bash ./scripts/ci-install.sh

      - name: Lint
        run: |
          nvim --headless -c "TSInstallSync query" -c "q"
          nvim -l scripts/format-queries.lua
          git diff --exit-code
